/*
 * OSM NB API featuring ETSI NFV SOL005
 * This is Open Source MANO Northbound API featuring ETSI NFV SOL005. For more information on OSM, you can visit [http://osm.etsi.org](http://osm.etsi.org). You can send us your comments and questions to OSM_TECH@list.etsi.org or join the [OpenSourceMANO Slack Workplace](https://join.slack.com/t/opensourcemano/shared_invite/enQtMzQ3MzYzNTQ0NDIyLWVkNTE4ZjZjNWI0ZTQyN2VhOTI1MjViMzU1NWYwMWM3ODI4NTQyY2VlODA2ZjczMWIyYTFkZWNiZmFkM2M2ZDk) 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: OSM_TECH@list.etsi.org
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.lcm.nfvo.osm.rest.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.v3.oas.annotations.media.Schema;

import java.util.*;

/**
 * InstantiateNsRequestAdditionalParamsForVnf
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2022-03-04T13:48:18.253Z[GMT]")
public class InstantiateNsRequestAdditionalParamsForVnf {
  @SerializedName("member-vnf-index")
  private String memberVnfIndex = null;

  @SerializedName("additionalParams")
  private Map<String, Object> additionalParams = null;

  @SerializedName("k8s-namespace")
  private String k8sNamespace = null;

  @SerializedName("additionalParamsForVdu")
  private List<InstantiateNsRequestAdditionalParamsForVdu> additionalParamsForVdu = null;

  @SerializedName("additionalParamsForKdu")
  private List<InstantiateNsRequestAdditionalParamsForKdu> additionalParamsForKdu = null;

  public InstantiateNsRequestAdditionalParamsForVnf memberVnfIndex(String memberVnfIndex) {
    this.memberVnfIndex = memberVnfIndex;
    return this;
  }

   /**
   * Get memberVnfIndex
   * @return memberVnfIndex
  **/
  @Schema(required = true, description = "")
  public String getMemberVnfIndex() {
    return memberVnfIndex;
  }

  public void setMemberVnfIndex(String memberVnfIndex) {
    this.memberVnfIndex = memberVnfIndex;
  }

  public InstantiateNsRequestAdditionalParamsForVnf additionalParams(Map<String, Object> additionalParams) {
    this.additionalParams = additionalParams;
    return this;
  }

  public InstantiateNsRequestAdditionalParamsForVnf putAdditionalParamsItem(String key, Object additionalParamsItem) {
    if (this.additionalParams == null) {
      this.additionalParams = new HashMap<String, Object>();
    }
    this.additionalParams.put(key, additionalParamsItem);
    return this;
  }

   /**
   * Get additionalParams
   * @return additionalParams
  **/
  @Schema(description = "")
  public Map<String, Object> getAdditionalParams() {
    return additionalParams;
  }

  public void setAdditionalParams(Map<String, Object> additionalParams) {
    this.additionalParams = additionalParams;
  }

  public InstantiateNsRequestAdditionalParamsForVnf k8sNamespace(String k8sNamespace) {
    this.k8sNamespace = k8sNamespace;
    return this;
  }

   /**
   * use this namespace for all the KDU deployed in this VNF (if any). By default it is used the id of the project 
   * @return k8sNamespace
  **/
  @Schema(description = "use this namespace for all the KDU deployed in this VNF (if any). By default it is used the id of the project ")
  public String getK8sNamespace() {
    return k8sNamespace;
  }

  public void setK8sNamespace(String k8sNamespace) {
    this.k8sNamespace = k8sNamespace;
  }

  public InstantiateNsRequestAdditionalParamsForVnf additionalParamsForVdu(List<InstantiateNsRequestAdditionalParamsForVdu> additionalParamsForVdu) {
    this.additionalParamsForVdu = additionalParamsForVdu;
    return this;
  }

  public InstantiateNsRequestAdditionalParamsForVnf addAdditionalParamsForVduItem(InstantiateNsRequestAdditionalParamsForVdu additionalParamsForVduItem) {
    if (this.additionalParamsForVdu == null) {
      this.additionalParamsForVdu = new ArrayList<InstantiateNsRequestAdditionalParamsForVdu>();
    }
    this.additionalParamsForVdu.add(additionalParamsForVduItem);
    return this;
  }

   /**
   * Get additionalParamsForVdu
   * @return additionalParamsForVdu
  **/
  @Schema(description = "")
  public List<InstantiateNsRequestAdditionalParamsForVdu> getAdditionalParamsForVdu() {
    return additionalParamsForVdu;
  }

  public void setAdditionalParamsForVdu(List<InstantiateNsRequestAdditionalParamsForVdu> additionalParamsForVdu) {
    this.additionalParamsForVdu = additionalParamsForVdu;
  }

  public InstantiateNsRequestAdditionalParamsForVnf additionalParamsForKdu(List<InstantiateNsRequestAdditionalParamsForKdu> additionalParamsForKdu) {
    this.additionalParamsForKdu = additionalParamsForKdu;
    return this;
  }

  public InstantiateNsRequestAdditionalParamsForVnf addAdditionalParamsForKduItem(InstantiateNsRequestAdditionalParamsForKdu additionalParamsForKduItem) {
    if (this.additionalParamsForKdu == null) {
      this.additionalParamsForKdu = new ArrayList<InstantiateNsRequestAdditionalParamsForKdu>();
    }
    this.additionalParamsForKdu.add(additionalParamsForKduItem);
    return this;
  }

   /**
   * Get additionalParamsForKdu
   * @return additionalParamsForKdu
  **/
  @Schema(description = "")
  public List<InstantiateNsRequestAdditionalParamsForKdu> getAdditionalParamsForKdu() {
    return additionalParamsForKdu;
  }

  public void setAdditionalParamsForKdu(List<InstantiateNsRequestAdditionalParamsForKdu> additionalParamsForKdu) {
    this.additionalParamsForKdu = additionalParamsForKdu;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InstantiateNsRequestAdditionalParamsForVnf instantiateNsRequestAdditionalParamsForVnf = (InstantiateNsRequestAdditionalParamsForVnf) o;
    return Objects.equals(this.memberVnfIndex, instantiateNsRequestAdditionalParamsForVnf.memberVnfIndex) &&
        Objects.equals(this.additionalParams, instantiateNsRequestAdditionalParamsForVnf.additionalParams) &&
        Objects.equals(this.k8sNamespace, instantiateNsRequestAdditionalParamsForVnf.k8sNamespace) &&
        Objects.equals(this.additionalParamsForVdu, instantiateNsRequestAdditionalParamsForVnf.additionalParamsForVdu) &&
        Objects.equals(this.additionalParamsForKdu, instantiateNsRequestAdditionalParamsForVnf.additionalParamsForKdu);
  }

  @Override
  public int hashCode() {
    return Objects.hash(memberVnfIndex, additionalParams, k8sNamespace, additionalParamsForVdu, additionalParamsForKdu);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InstantiateNsRequestAdditionalParamsForVnf {\n");

    sb.append("    memberVnfIndex: ").append(toIndentedString(memberVnfIndex)).append("\n");
    sb.append("    additionalParams: ").append(toIndentedString(additionalParams)).append("\n");
    sb.append("    k8sNamespace: ").append(toIndentedString(k8sNamespace)).append("\n");
    sb.append("    additionalParamsForVdu: ").append(toIndentedString(additionalParamsForVdu)).append("\n");
    sb.append("    additionalParamsForKdu: ").append(toIndentedString(additionalParamsForKdu)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
